#!/usr/bin/perl -w

$#ARGV == 2 || die "usage: convert-locks.pl file variable outputfile\n";

my $file = $ARGV[0];
my $var = $ARGV[1];
my $output = $ARGV[2];

open(IN, $file) || die "can not read $file";
open(OUT, ">$output") || die "can not create output file $output";

while (<IN>) {
    if (/\b$var\b/) {
	    s/^lock_t(\s+)$var\b/spinlock_t$1$var/g;

	    s/([^_])\block_t(\s+$var\b)/$1spinlock_t$2/g;

	    s/(PER_CPU.*[^_])\block_t,(\s+$var\b)/$1spinlock_t,$2/g;

	    s/([^_])\bacquire_lock([^)]*\(\s*\&?\s*$var\b[^_])/$1spin_lock$2/g;

	    s/([^_])\brelease_lock([^)]*\(\s*\&?\s*$var\b[^_])/$1spin_unlock$2/g;

	    s/([^_])\btrylock([^)]*\(\s*\&?\s*$var\b[^_])/$1spin_trylock$2/g;

	    s/([^_])\block(_init\s*\(\s*\&?\s*$var\s*\))/$1spin_lock$2/g;

	    s/([^_])\bassert_lock(_locked\s*\(\s*\&?\s*$var\s*\))/$1assert_spin$2/g;

	    s/([^_])\block(_(can_lock|is_locked|is_contended)\s*\(\s*\&?\s*$var\s*\))/$1spin$2/g;

	    s/([^_])\bassert_lock(_locked\s*\(\s*\&?\s*$var\s*\))/$1assert_spin$2/g;
	    s/([^_])\batomic_dec_and_(lock\s*\([^\)]*,\s*\&?\s*$var\s*\))/$1atomic_dec_and_spin$2/g;

	    s/([^_])\bcond_resched_(lock\s*\(\s*\&?\s*$var\s*\))/$1cond_resched_spin$2/g;

	    s/([^_])\block_needbreak(\s*\(\s*\&?\s*$var\s*\))/$1spin_needbreak$2/g;
	    
	    s/([^_])\bLOCK_UNLOCKED(\s*\(\s*\&?\s*$var\s*\))/$1SPIN_LOCK_UNLOCKED$2/g;
	    s/([^_])\b__LOCK_UNLOCKED(\s*\(\s*\&?\s*$var\s*\))/$1__SPIN_LOCK_UNLOCKED$2/g;

	    s/([^_])\b__LOCK(\s*\(\s*\s*$var\s*\))/$1__SPIN_LOCK$2/g;
	    s/^__LOCK(\s*\(\s*\s*$var\s*\))/__SPIN_LOCK$1/g;

	    s/([^_])\bDEFINE_LOCK(\s*\(\s*$var\s*\))/$1DEFINE_SPINLOCK$2/g;
	    s/^DEFINE_LOCK(\s*\(\s*$var\s*\))/DEFINE_SPINLOCK$1/g;
	}

	print OUT;
}

exit 0
